// Package define ...
//
// Description : define ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 2022-05-20 23:09
package define

// LsFileInfo ls查询出来的文件详细信息
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 23:10 2022/5/20
type LsFileInfo struct {
	IsDir        bool            `json:"is_dir"`        // 是否是目录
	IsLink       bool            `json:"is_link"`       // 是否链接文件
	SourcePath   string          `json:"source_path"`   // 是链接文件时, 链接的源文件路径
	IsHidden     bool            `json:"is_hidden"`     // 是否是隐藏文件
	FullPath     string          `json:"full_path"`     // 文件全路径
	RelativePath string          `json:"relative_path"` // 相对路径
	Name         string          `json:"name"`          // 文件名
	Type         string          `json:"type"`          // 文件类型, 如果为目录, 至为 - , 如果非 .xxx 结尾, 可执行为 bin , 不可执行为 unknown
	Permission   *FullPermission `json:"permission"`    // 文件权限
	Dir          string          `json:"dir"`           // 文件所属目录
	ReferenceCnt int             `json:"reference_cnt"` // 引用次数
	Size         int64           `json:"size"`          // 大小， bytes
	User         string          `json:"user"`          // 所属用户
	Group        string          `json:"group"`         // 所属用户组
	ModifyTime   string          `json:"modify_time"`   // 最近修改时间
}

// FullPermission 文件权限
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 23:45 2022/5/20
type FullPermission struct {
	User  FilePermission `json:"user"`
	Group FilePermission `json:"group"`
	Other FilePermission `json:"other"`
}

// FilePermission 文件操作权限
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 23:31 2022/5/20
type FilePermission struct {
	Read  bool `json:"read"`
	Write bool `json:"write"`
	Exec  bool `json:"exec"`
}
